#ifndef _H_4FA69BE4307FA2501CE1671CB9022180_Dock_Feedback_DCPS_H_
#define _H_4FA69BE4307FA2501CE1671CB9022180_Dock_Feedback_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Dock_Feedback_.h"


namespace py_trees_ros_interfaces
{
    namespace action
    {
        namespace dds_
        {
            class Dock_Feedback_TypeSupportInterface;

            typedef Dock_Feedback_TypeSupportInterface * Dock_Feedback_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Dock_Feedback_TypeSupportInterface> Dock_Feedback_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Dock_Feedback_TypeSupportInterface> Dock_Feedback_TypeSupportInterface_out;


            class Dock_Feedback_DataWriter;

            typedef Dock_Feedback_DataWriter * Dock_Feedback_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Dock_Feedback_DataWriter> Dock_Feedback_DataWriter_var;
            typedef DDS_DCPSInterface_out < Dock_Feedback_DataWriter> Dock_Feedback_DataWriter_out;


            class Dock_Feedback_DataReader;

            typedef Dock_Feedback_DataReader * Dock_Feedback_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Dock_Feedback_DataReader> Dock_Feedback_DataReader_var;
            typedef DDS_DCPSInterface_out < Dock_Feedback_DataReader> Dock_Feedback_DataReader_out;


            class Dock_Feedback_DataReaderView;

            typedef Dock_Feedback_DataReaderView * Dock_Feedback_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Dock_Feedback_DataReaderView> Dock_Feedback_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Dock_Feedback_DataReaderView> Dock_Feedback_DataReaderView_out;

            struct Dock_Feedback_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Dock_Feedback_, struct Dock_Feedback_Seq_uniq_> Dock_Feedback_Seq;
            typedef DDS_DCPSSequence_var < Dock_Feedback_Seq> Dock_Feedback_Seq_var;
            typedef DDS_DCPSSequence_out < Dock_Feedback_Seq> Dock_Feedback_Seq_out;

            class  Dock_Feedback_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Dock_Feedback_TypeSupportInterface_ptr _ptr_type;
                typedef Dock_Feedback_TypeSupportInterface_var _var_type;

                static Dock_Feedback_TypeSupportInterface_ptr _duplicate (Dock_Feedback_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Dock_Feedback_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Dock_Feedback_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Dock_Feedback_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Dock_Feedback_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Dock_Feedback_TypeSupportInterface () {};
                ~Dock_Feedback_TypeSupportInterface () {};
            private:
                Dock_Feedback_TypeSupportInterface (const Dock_Feedback_TypeSupportInterface &);
                Dock_Feedback_TypeSupportInterface & operator = (const Dock_Feedback_TypeSupportInterface &);
            };

            class  Dock_Feedback_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Dock_Feedback_DataWriter_ptr _ptr_type;
                typedef Dock_Feedback_DataWriter_var _var_type;

                static Dock_Feedback_DataWriter_ptr _duplicate (Dock_Feedback_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Dock_Feedback_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Dock_Feedback_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Dock_Feedback_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Dock_Feedback_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Dock_Feedback_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Dock_Feedback_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Dock_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Dock_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Dock_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Dock_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Dock_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Dock_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Dock_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Dock_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Dock_Feedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Dock_Feedback_& instance_data) = 0;

            protected:
                Dock_Feedback_DataWriter () {};
                ~Dock_Feedback_DataWriter () {};
            private:
                Dock_Feedback_DataWriter (const Dock_Feedback_DataWriter &);
                Dock_Feedback_DataWriter & operator = (const Dock_Feedback_DataWriter &);
            };

            class  Dock_Feedback_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Dock_Feedback_DataReader_ptr _ptr_type;
                typedef Dock_Feedback_DataReader_var _var_type;

                static Dock_Feedback_DataReader_ptr _duplicate (Dock_Feedback_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Dock_Feedback_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Dock_Feedback_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Dock_Feedback_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Dock_Feedback_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Dock_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Dock_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Dock_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Dock_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Dock_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Dock_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Dock_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Dock_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Dock_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Dock_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Dock_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Dock_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Dock_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Dock_Feedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Dock_Feedback_& instance) = 0;

            protected:
                Dock_Feedback_DataReader () {};
                ~Dock_Feedback_DataReader () {};
            private:
                Dock_Feedback_DataReader (const Dock_Feedback_DataReader &);
                Dock_Feedback_DataReader & operator = (const Dock_Feedback_DataReader &);
            };

            class  Dock_Feedback_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Dock_Feedback_DataReaderView_ptr _ptr_type;
                typedef Dock_Feedback_DataReaderView_var _var_type;

                static Dock_Feedback_DataReaderView_ptr _duplicate (Dock_Feedback_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Dock_Feedback_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Dock_Feedback_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Dock_Feedback_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Dock_Feedback_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Dock_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Dock_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Dock_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Dock_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Dock_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Dock_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Dock_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Dock_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Dock_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Dock_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Dock_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Dock_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Dock_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Dock_Feedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Dock_Feedback_& instance) = 0;

            protected:
                Dock_Feedback_DataReaderView () {};
                ~Dock_Feedback_DataReaderView () {};
            private:
                Dock_Feedback_DataReaderView (const Dock_Feedback_DataReaderView &);
                Dock_Feedback_DataReaderView & operator = (const Dock_Feedback_DataReaderView &);
            };
        }

    }

}

#endif
