#ifndef _H_1EF9703DC095384CF9F6A4FF6F3F05D4_MoveBase_Goal_Request__H_
#define _H_1EF9703DC095384CF9F6A4FF6F3F05D4_MoveBase_Goal_Request__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "unique_identifier_msgs/msg/dds_opensplice/UUID_.h"
#include "geometry_msgs/msg/dds_opensplice/PoseStamped_.h"


namespace py_trees_ros_interfaces
{
    namespace action
    {
        namespace dds_
        {
            struct  MoveBase_Goal_Request_
            {
                ::unique_identifier_msgs::msg::dds_::UUID_ action_goal_id_;
                ::geometry_msgs::msg::dds_::PoseStamped_ target_pose_;
            };

            typedef DDS_DCPSStruct_var<MoveBase_Goal_Request_> MoveBase_Goal_Request__var;
            typedef DDS_DCPSStruct_out < MoveBase_Goal_Request_> MoveBase_Goal_Request__out;

        }

    }

}

#endif /* _H_1EF9703DC095384CF9F6A4FF6F3F05D4_MoveBase_Goal_Request__H_ */
