#ifndef _H_2DD7E68A94FDC3F20BBA8609A16C5AB1_Rotate_Feedback_DCPS_H_
#define _H_2DD7E68A94FDC3F20BBA8609A16C5AB1_Rotate_Feedback_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Rotate_Feedback_.h"


namespace py_trees_ros_interfaces
{
    namespace action
    {
        namespace dds_
        {
            class Rotate_Feedback_TypeSupportInterface;

            typedef Rotate_Feedback_TypeSupportInterface * Rotate_Feedback_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Rotate_Feedback_TypeSupportInterface> Rotate_Feedback_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Rotate_Feedback_TypeSupportInterface> Rotate_Feedback_TypeSupportInterface_out;


            class Rotate_Feedback_DataWriter;

            typedef Rotate_Feedback_DataWriter * Rotate_Feedback_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Rotate_Feedback_DataWriter> Rotate_Feedback_DataWriter_var;
            typedef DDS_DCPSInterface_out < Rotate_Feedback_DataWriter> Rotate_Feedback_DataWriter_out;


            class Rotate_Feedback_DataReader;

            typedef Rotate_Feedback_DataReader * Rotate_Feedback_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Rotate_Feedback_DataReader> Rotate_Feedback_DataReader_var;
            typedef DDS_DCPSInterface_out < Rotate_Feedback_DataReader> Rotate_Feedback_DataReader_out;


            class Rotate_Feedback_DataReaderView;

            typedef Rotate_Feedback_DataReaderView * Rotate_Feedback_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Rotate_Feedback_DataReaderView> Rotate_Feedback_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Rotate_Feedback_DataReaderView> Rotate_Feedback_DataReaderView_out;

            struct Rotate_Feedback_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Rotate_Feedback_, struct Rotate_Feedback_Seq_uniq_> Rotate_Feedback_Seq;
            typedef DDS_DCPSSequence_var < Rotate_Feedback_Seq> Rotate_Feedback_Seq_var;
            typedef DDS_DCPSSequence_out < Rotate_Feedback_Seq> Rotate_Feedback_Seq_out;

            class  Rotate_Feedback_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Rotate_Feedback_TypeSupportInterface_ptr _ptr_type;
                typedef Rotate_Feedback_TypeSupportInterface_var _var_type;

                static Rotate_Feedback_TypeSupportInterface_ptr _duplicate (Rotate_Feedback_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Rotate_Feedback_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Rotate_Feedback_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Rotate_Feedback_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Rotate_Feedback_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Rotate_Feedback_TypeSupportInterface () {};
                ~Rotate_Feedback_TypeSupportInterface () {};
            private:
                Rotate_Feedback_TypeSupportInterface (const Rotate_Feedback_TypeSupportInterface &);
                Rotate_Feedback_TypeSupportInterface & operator = (const Rotate_Feedback_TypeSupportInterface &);
            };

            class  Rotate_Feedback_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Rotate_Feedback_DataWriter_ptr _ptr_type;
                typedef Rotate_Feedback_DataWriter_var _var_type;

                static Rotate_Feedback_DataWriter_ptr _duplicate (Rotate_Feedback_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Rotate_Feedback_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Rotate_Feedback_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Rotate_Feedback_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Rotate_Feedback_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Rotate_Feedback_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Rotate_Feedback_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Rotate_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Rotate_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Rotate_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Rotate_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Rotate_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Rotate_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Rotate_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Rotate_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Rotate_Feedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Rotate_Feedback_& instance_data) = 0;

            protected:
                Rotate_Feedback_DataWriter () {};
                ~Rotate_Feedback_DataWriter () {};
            private:
                Rotate_Feedback_DataWriter (const Rotate_Feedback_DataWriter &);
                Rotate_Feedback_DataWriter & operator = (const Rotate_Feedback_DataWriter &);
            };

            class  Rotate_Feedback_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Rotate_Feedback_DataReader_ptr _ptr_type;
                typedef Rotate_Feedback_DataReader_var _var_type;

                static Rotate_Feedback_DataReader_ptr _duplicate (Rotate_Feedback_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Rotate_Feedback_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Rotate_Feedback_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Rotate_Feedback_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Rotate_Feedback_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Rotate_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Rotate_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Rotate_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Rotate_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Rotate_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Rotate_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Rotate_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Rotate_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Rotate_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Rotate_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Rotate_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Rotate_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Rotate_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Rotate_Feedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Rotate_Feedback_& instance) = 0;

            protected:
                Rotate_Feedback_DataReader () {};
                ~Rotate_Feedback_DataReader () {};
            private:
                Rotate_Feedback_DataReader (const Rotate_Feedback_DataReader &);
                Rotate_Feedback_DataReader & operator = (const Rotate_Feedback_DataReader &);
            };

            class  Rotate_Feedback_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Rotate_Feedback_DataReaderView_ptr _ptr_type;
                typedef Rotate_Feedback_DataReaderView_var _var_type;

                static Rotate_Feedback_DataReaderView_ptr _duplicate (Rotate_Feedback_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Rotate_Feedback_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Rotate_Feedback_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Rotate_Feedback_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Rotate_Feedback_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Rotate_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Rotate_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Rotate_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Rotate_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Rotate_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Rotate_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Rotate_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Rotate_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Rotate_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Rotate_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Rotate_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Rotate_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Rotate_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Rotate_Feedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Rotate_Feedback_& instance) = 0;

            protected:
                Rotate_Feedback_DataReaderView () {};
                ~Rotate_Feedback_DataReaderView () {};
            private:
                Rotate_Feedback_DataReaderView (const Rotate_Feedback_DataReaderView &);
                Rotate_Feedback_DataReaderView & operator = (const Rotate_Feedback_DataReaderView &);
            };
        }

    }

}

#endif
