// generated from rosidl_generator_cpp/resource/msg__struct.hpp.em
// generated code does not contain a copyright notice

#ifndef PY_TREES_ROS_INTERFACES__ACTION__MOVE_BASE__GOAL__REQUEST__STRUCT_HPP_
#define PY_TREES_ROS_INTERFACES__ACTION__MOVE_BASE__GOAL__REQUEST__STRUCT_HPP_

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32) && defined(ERROR)
  #undef ERROR
#endif

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// include message dependencies
#include "geometry_msgs/msg/pose_stamped.hpp"  // target_pose
#include "unique_identifier_msgs/msg/uuid.hpp"  // action_goal_id

#ifndef _WIN32
# define DEPRECATED_py_trees_ros_interfaces_action_MoveBase_Goal_Request __attribute__((deprecated))
#else
# define DEPRECATED_py_trees_ros_interfaces_action_MoveBase_Goal_Request __declspec(deprecated)
#endif

namespace py_trees_ros_interfaces
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct MoveBase_Goal_Request_
{
  using Type = MoveBase_Goal_Request_<ContainerAllocator>;

  explicit MoveBase_Goal_Request_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : action_goal_id(_init),
    target_pose(_init)
  {
    (void)_init;
  }

  explicit MoveBase_Goal_Request_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : action_goal_id(_alloc, _init),
    target_pose(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _action_goal_id_type =
    unique_identifier_msgs::msg::UUID_<ContainerAllocator>;
  _action_goal_id_type action_goal_id;
  using _target_pose_type =
    geometry_msgs::msg::PoseStamped_<ContainerAllocator>;
  _target_pose_type target_pose;

  // setters for named parameter idiom
  Type * set__action_goal_id(
    const unique_identifier_msgs::msg::UUID_<ContainerAllocator> & _arg)
  {
    this->action_goal_id = _arg;
    return this;
  }
  Type * set__target_pose(
    const geometry_msgs::msg::PoseStamped_<ContainerAllocator> & _arg)
  {
    this->target_pose = _arg;
    return this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    py_trees_ros_interfaces::action::MoveBase_Goal_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const py_trees_ros_interfaces::action::MoveBase_Goal_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<py_trees_ros_interfaces::action::MoveBase_Goal_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<py_trees_ros_interfaces::action::MoveBase_Goal_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      py_trees_ros_interfaces::action::MoveBase_Goal_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<py_trees_ros_interfaces::action::MoveBase_Goal_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      py_trees_ros_interfaces::action::MoveBase_Goal_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<py_trees_ros_interfaces::action::MoveBase_Goal_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<py_trees_ros_interfaces::action::MoveBase_Goal_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<py_trees_ros_interfaces::action::MoveBase_Goal_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED_py_trees_ros_interfaces_action_MoveBase_Goal_Request
    std::shared_ptr<py_trees_ros_interfaces::action::MoveBase_Goal_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED_py_trees_ros_interfaces_action_MoveBase_Goal_Request
    std::shared_ptr<py_trees_ros_interfaces::action::MoveBase_Goal_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const MoveBase_Goal_Request_ & other) const
  {
    if (this->action_goal_id != other.action_goal_id) {
      return false;
    }
    if (this->target_pose != other.target_pose) {
      return false;
    }
    return true;
  }
  bool operator!=(const MoveBase_Goal_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct MoveBase_Goal_Request_

// alias to use template instance with default allocator
using MoveBase_Goal_Request =
  py_trees_ros_interfaces::action::MoveBase_Goal_Request_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace py_trees_ros_interfaces

#endif  // PY_TREES_ROS_INTERFACES__ACTION__MOVE_BASE__GOAL__REQUEST__STRUCT_HPP_
