// generated from rosidl_generator_cpp/resource/msg__struct.hpp.em
// generated code does not contain a copyright notice

#ifndef PY_TREES_ROS_INTERFACES__MSG__BEHAVIOUR_TREE__STRUCT_HPP_
#define PY_TREES_ROS_INTERFACES__MSG__BEHAVIOUR_TREE__STRUCT_HPP_

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32) && defined(ERROR)
  #undef ERROR
#endif

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// include message dependencies
#include "py_trees_ros_interfaces/msg/behaviour.hpp"  // behaviours
#include "py_trees_ros_interfaces/msg/statistics.hpp"  // statistics

#ifndef _WIN32
# define DEPRECATED_py_trees_ros_interfaces_msg_BehaviourTree __attribute__((deprecated))
#else
# define DEPRECATED_py_trees_ros_interfaces_msg_BehaviourTree __declspec(deprecated)
#endif

namespace py_trees_ros_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct BehaviourTree_
{
  using Type = BehaviourTree_<ContainerAllocator>;

  explicit BehaviourTree_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : statistics(_init)
  {
    (void)_init;
  }

  explicit BehaviourTree_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : statistics(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _behaviours_type =
    std::vector<py_trees_ros_interfaces::msg::Behaviour_<ContainerAllocator>, typename ContainerAllocator::template rebind<py_trees_ros_interfaces::msg::Behaviour_<ContainerAllocator>>::other>;
  _behaviours_type behaviours;
  using _statistics_type =
    py_trees_ros_interfaces::msg::Statistics_<ContainerAllocator>;
  _statistics_type statistics;

  // setters for named parameter idiom
  Type * set__behaviours(
    const std::vector<py_trees_ros_interfaces::msg::Behaviour_<ContainerAllocator>, typename ContainerAllocator::template rebind<py_trees_ros_interfaces::msg::Behaviour_<ContainerAllocator>>::other> & _arg)
  {
    this->behaviours = _arg;
    return this;
  }
  Type * set__statistics(
    const py_trees_ros_interfaces::msg::Statistics_<ContainerAllocator> & _arg)
  {
    this->statistics = _arg;
    return this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    py_trees_ros_interfaces::msg::BehaviourTree_<ContainerAllocator> *;
  using ConstRawPtr =
    const py_trees_ros_interfaces::msg::BehaviourTree_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<py_trees_ros_interfaces::msg::BehaviourTree_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<py_trees_ros_interfaces::msg::BehaviourTree_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      py_trees_ros_interfaces::msg::BehaviourTree_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<py_trees_ros_interfaces::msg::BehaviourTree_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      py_trees_ros_interfaces::msg::BehaviourTree_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<py_trees_ros_interfaces::msg::BehaviourTree_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<py_trees_ros_interfaces::msg::BehaviourTree_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<py_trees_ros_interfaces::msg::BehaviourTree_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED_py_trees_ros_interfaces_msg_BehaviourTree
    std::shared_ptr<py_trees_ros_interfaces::msg::BehaviourTree_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED_py_trees_ros_interfaces_msg_BehaviourTree
    std::shared_ptr<py_trees_ros_interfaces::msg::BehaviourTree_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const BehaviourTree_ & other) const
  {
    if (this->behaviours != other.behaviours) {
      return false;
    }
    if (this->statistics != other.statistics) {
      return false;
    }
    return true;
  }
  bool operator!=(const BehaviourTree_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct BehaviourTree_

// alias to use template instance with default allocator
using BehaviourTree =
  py_trees_ros_interfaces::msg::BehaviourTree_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace py_trees_ros_interfaces

#endif  // PY_TREES_ROS_INTERFACES__MSG__BEHAVIOUR_TREE__STRUCT_HPP_
