#ifndef _H_6E1CC9C4A0283C4E63893B3812C17F5A_IntrospectPublishers_Request_DCPS_H_
#define _H_6E1CC9C4A0283C4E63893B3812C17F5A_IntrospectPublishers_Request_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "IntrospectPublishers_Request_.h"


namespace py_trees_ros_interfaces
{
    namespace srv
    {
        namespace dds_
        {
            class IntrospectPublishers_Request_TypeSupportInterface;

            typedef IntrospectPublishers_Request_TypeSupportInterface * IntrospectPublishers_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < IntrospectPublishers_Request_TypeSupportInterface> IntrospectPublishers_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < IntrospectPublishers_Request_TypeSupportInterface> IntrospectPublishers_Request_TypeSupportInterface_out;


            class IntrospectPublishers_Request_DataWriter;

            typedef IntrospectPublishers_Request_DataWriter * IntrospectPublishers_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < IntrospectPublishers_Request_DataWriter> IntrospectPublishers_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < IntrospectPublishers_Request_DataWriter> IntrospectPublishers_Request_DataWriter_out;


            class IntrospectPublishers_Request_DataReader;

            typedef IntrospectPublishers_Request_DataReader * IntrospectPublishers_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < IntrospectPublishers_Request_DataReader> IntrospectPublishers_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < IntrospectPublishers_Request_DataReader> IntrospectPublishers_Request_DataReader_out;


            class IntrospectPublishers_Request_DataReaderView;

            typedef IntrospectPublishers_Request_DataReaderView * IntrospectPublishers_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < IntrospectPublishers_Request_DataReaderView> IntrospectPublishers_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < IntrospectPublishers_Request_DataReaderView> IntrospectPublishers_Request_DataReaderView_out;

            struct IntrospectPublishers_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < IntrospectPublishers_Request_, struct IntrospectPublishers_Request_Seq_uniq_> IntrospectPublishers_Request_Seq;
            typedef DDS_DCPSSequence_var < IntrospectPublishers_Request_Seq> IntrospectPublishers_Request_Seq_var;
            typedef DDS_DCPSSequence_out < IntrospectPublishers_Request_Seq> IntrospectPublishers_Request_Seq_out;

            class  IntrospectPublishers_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef IntrospectPublishers_Request_TypeSupportInterface_ptr _ptr_type;
                typedef IntrospectPublishers_Request_TypeSupportInterface_var _var_type;

                static IntrospectPublishers_Request_TypeSupportInterface_ptr _duplicate (IntrospectPublishers_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IntrospectPublishers_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static IntrospectPublishers_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IntrospectPublishers_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                IntrospectPublishers_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                IntrospectPublishers_Request_TypeSupportInterface () {};
                ~IntrospectPublishers_Request_TypeSupportInterface () {};
            private:
                IntrospectPublishers_Request_TypeSupportInterface (const IntrospectPublishers_Request_TypeSupportInterface &);
                IntrospectPublishers_Request_TypeSupportInterface & operator = (const IntrospectPublishers_Request_TypeSupportInterface &);
            };

            class  IntrospectPublishers_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef IntrospectPublishers_Request_DataWriter_ptr _ptr_type;
                typedef IntrospectPublishers_Request_DataWriter_var _var_type;

                static IntrospectPublishers_Request_DataWriter_ptr _duplicate (IntrospectPublishers_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IntrospectPublishers_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static IntrospectPublishers_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IntrospectPublishers_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                IntrospectPublishers_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const IntrospectPublishers_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const IntrospectPublishers_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const IntrospectPublishers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const IntrospectPublishers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const IntrospectPublishers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const IntrospectPublishers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const IntrospectPublishers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const IntrospectPublishers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const IntrospectPublishers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const IntrospectPublishers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (IntrospectPublishers_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const IntrospectPublishers_Request_& instance_data) = 0;

            protected:
                IntrospectPublishers_Request_DataWriter () {};
                ~IntrospectPublishers_Request_DataWriter () {};
            private:
                IntrospectPublishers_Request_DataWriter (const IntrospectPublishers_Request_DataWriter &);
                IntrospectPublishers_Request_DataWriter & operator = (const IntrospectPublishers_Request_DataWriter &);
            };

            class  IntrospectPublishers_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef IntrospectPublishers_Request_DataReader_ptr _ptr_type;
                typedef IntrospectPublishers_Request_DataReader_var _var_type;

                static IntrospectPublishers_Request_DataReader_ptr _duplicate (IntrospectPublishers_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IntrospectPublishers_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static IntrospectPublishers_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IntrospectPublishers_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                IntrospectPublishers_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (IntrospectPublishers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (IntrospectPublishers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (IntrospectPublishers_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const IntrospectPublishers_Request_& instance) = 0;

            protected:
                IntrospectPublishers_Request_DataReader () {};
                ~IntrospectPublishers_Request_DataReader () {};
            private:
                IntrospectPublishers_Request_DataReader (const IntrospectPublishers_Request_DataReader &);
                IntrospectPublishers_Request_DataReader & operator = (const IntrospectPublishers_Request_DataReader &);
            };

            class  IntrospectPublishers_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef IntrospectPublishers_Request_DataReaderView_ptr _ptr_type;
                typedef IntrospectPublishers_Request_DataReaderView_var _var_type;

                static IntrospectPublishers_Request_DataReaderView_ptr _duplicate (IntrospectPublishers_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IntrospectPublishers_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static IntrospectPublishers_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IntrospectPublishers_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                IntrospectPublishers_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (IntrospectPublishers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (IntrospectPublishers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (IntrospectPublishers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (IntrospectPublishers_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const IntrospectPublishers_Request_& instance) = 0;

            protected:
                IntrospectPublishers_Request_DataReaderView () {};
                ~IntrospectPublishers_Request_DataReaderView () {};
            private:
                IntrospectPublishers_Request_DataReaderView (const IntrospectPublishers_Request_DataReaderView &);
                IntrospectPublishers_Request_DataReaderView & operator = (const IntrospectPublishers_Request_DataReaderView &);
            };
        }

    }

}

#endif
