#ifndef _H_A8DE2278493C8299809634CF320B6BFA_IntrospectSubscribers_Response_DCPS_H_
#define _H_A8DE2278493C8299809634CF320B6BFA_IntrospectSubscribers_Response_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "IntrospectSubscribers_Response_.h"


namespace py_trees_ros_interfaces
{
    namespace srv
    {
        namespace dds_
        {
            class IntrospectSubscribers_Response_TypeSupportInterface;

            typedef IntrospectSubscribers_Response_TypeSupportInterface * IntrospectSubscribers_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < IntrospectSubscribers_Response_TypeSupportInterface> IntrospectSubscribers_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < IntrospectSubscribers_Response_TypeSupportInterface> IntrospectSubscribers_Response_TypeSupportInterface_out;


            class IntrospectSubscribers_Response_DataWriter;

            typedef IntrospectSubscribers_Response_DataWriter * IntrospectSubscribers_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < IntrospectSubscribers_Response_DataWriter> IntrospectSubscribers_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < IntrospectSubscribers_Response_DataWriter> IntrospectSubscribers_Response_DataWriter_out;


            class IntrospectSubscribers_Response_DataReader;

            typedef IntrospectSubscribers_Response_DataReader * IntrospectSubscribers_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < IntrospectSubscribers_Response_DataReader> IntrospectSubscribers_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < IntrospectSubscribers_Response_DataReader> IntrospectSubscribers_Response_DataReader_out;


            class IntrospectSubscribers_Response_DataReaderView;

            typedef IntrospectSubscribers_Response_DataReaderView * IntrospectSubscribers_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < IntrospectSubscribers_Response_DataReaderView> IntrospectSubscribers_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < IntrospectSubscribers_Response_DataReaderView> IntrospectSubscribers_Response_DataReaderView_out;

            struct IntrospectSubscribers_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < IntrospectSubscribers_Response_, struct IntrospectSubscribers_Response_Seq_uniq_> IntrospectSubscribers_Response_Seq;
            typedef DDS_DCPSSequence_var < IntrospectSubscribers_Response_Seq> IntrospectSubscribers_Response_Seq_var;
            typedef DDS_DCPSSequence_out < IntrospectSubscribers_Response_Seq> IntrospectSubscribers_Response_Seq_out;

            class  IntrospectSubscribers_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef IntrospectSubscribers_Response_TypeSupportInterface_ptr _ptr_type;
                typedef IntrospectSubscribers_Response_TypeSupportInterface_var _var_type;

                static IntrospectSubscribers_Response_TypeSupportInterface_ptr _duplicate (IntrospectSubscribers_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IntrospectSubscribers_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static IntrospectSubscribers_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IntrospectSubscribers_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                IntrospectSubscribers_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                IntrospectSubscribers_Response_TypeSupportInterface () {};
                ~IntrospectSubscribers_Response_TypeSupportInterface () {};
            private:
                IntrospectSubscribers_Response_TypeSupportInterface (const IntrospectSubscribers_Response_TypeSupportInterface &);
                IntrospectSubscribers_Response_TypeSupportInterface & operator = (const IntrospectSubscribers_Response_TypeSupportInterface &);
            };

            class  IntrospectSubscribers_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef IntrospectSubscribers_Response_DataWriter_ptr _ptr_type;
                typedef IntrospectSubscribers_Response_DataWriter_var _var_type;

                static IntrospectSubscribers_Response_DataWriter_ptr _duplicate (IntrospectSubscribers_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IntrospectSubscribers_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static IntrospectSubscribers_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IntrospectSubscribers_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                IntrospectSubscribers_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const IntrospectSubscribers_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const IntrospectSubscribers_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const IntrospectSubscribers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const IntrospectSubscribers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const IntrospectSubscribers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const IntrospectSubscribers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const IntrospectSubscribers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const IntrospectSubscribers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const IntrospectSubscribers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const IntrospectSubscribers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (IntrospectSubscribers_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const IntrospectSubscribers_Response_& instance_data) = 0;

            protected:
                IntrospectSubscribers_Response_DataWriter () {};
                ~IntrospectSubscribers_Response_DataWriter () {};
            private:
                IntrospectSubscribers_Response_DataWriter (const IntrospectSubscribers_Response_DataWriter &);
                IntrospectSubscribers_Response_DataWriter & operator = (const IntrospectSubscribers_Response_DataWriter &);
            };

            class  IntrospectSubscribers_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef IntrospectSubscribers_Response_DataReader_ptr _ptr_type;
                typedef IntrospectSubscribers_Response_DataReader_var _var_type;

                static IntrospectSubscribers_Response_DataReader_ptr _duplicate (IntrospectSubscribers_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IntrospectSubscribers_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static IntrospectSubscribers_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IntrospectSubscribers_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                IntrospectSubscribers_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (IntrospectSubscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (IntrospectSubscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (IntrospectSubscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (IntrospectSubscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (IntrospectSubscribers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (IntrospectSubscribers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (IntrospectSubscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (IntrospectSubscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (IntrospectSubscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (IntrospectSubscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (IntrospectSubscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (IntrospectSubscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (IntrospectSubscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (IntrospectSubscribers_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const IntrospectSubscribers_Response_& instance) = 0;

            protected:
                IntrospectSubscribers_Response_DataReader () {};
                ~IntrospectSubscribers_Response_DataReader () {};
            private:
                IntrospectSubscribers_Response_DataReader (const IntrospectSubscribers_Response_DataReader &);
                IntrospectSubscribers_Response_DataReader & operator = (const IntrospectSubscribers_Response_DataReader &);
            };

            class  IntrospectSubscribers_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef IntrospectSubscribers_Response_DataReaderView_ptr _ptr_type;
                typedef IntrospectSubscribers_Response_DataReaderView_var _var_type;

                static IntrospectSubscribers_Response_DataReaderView_ptr _duplicate (IntrospectSubscribers_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IntrospectSubscribers_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static IntrospectSubscribers_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IntrospectSubscribers_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                IntrospectSubscribers_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (IntrospectSubscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (IntrospectSubscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (IntrospectSubscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (IntrospectSubscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (IntrospectSubscribers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (IntrospectSubscribers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (IntrospectSubscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (IntrospectSubscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (IntrospectSubscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (IntrospectSubscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (IntrospectSubscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (IntrospectSubscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (IntrospectSubscribers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (IntrospectSubscribers_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const IntrospectSubscribers_Response_& instance) = 0;

            protected:
                IntrospectSubscribers_Response_DataReaderView () {};
                ~IntrospectSubscribers_Response_DataReaderView () {};
            private:
                IntrospectSubscribers_Response_DataReaderView (const IntrospectSubscribers_Response_DataReaderView &);
                IntrospectSubscribers_Response_DataReaderView & operator = (const IntrospectSubscribers_Response_DataReaderView &);
            };
        }

    }

}

#endif
