// generated from rosidl_generator_cpp/resource/msg__struct.hpp.em
// generated code does not contain a copyright notice

#ifndef PY_TREES_ROS_INTERFACES__SRV__INTROSPECT_PUBLISHERS__RESPONSE__STRUCT_HPP_
#define PY_TREES_ROS_INTERFACES__SRV__INTROSPECT_PUBLISHERS__RESPONSE__STRUCT_HPP_

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32) && defined(ERROR)
  #undef ERROR
#endif

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// include message dependencies
#include "py_trees_ros_interfaces/msg/publisher_details.hpp"  // publisher_details

#ifndef _WIN32
# define DEPRECATED_py_trees_ros_interfaces_srv_IntrospectPublishers_Response __attribute__((deprecated))
#else
# define DEPRECATED_py_trees_ros_interfaces_srv_IntrospectPublishers_Response __declspec(deprecated)
#endif

namespace py_trees_ros_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct IntrospectPublishers_Response_
{
  using Type = IntrospectPublishers_Response_<ContainerAllocator>;

  explicit IntrospectPublishers_Response_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    (void)_init;
  }

  explicit IntrospectPublishers_Response_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    (void)_init;
    (void)_alloc;
  }

  // field types and members
  using _publisher_details_type =
    std::vector<py_trees_ros_interfaces::msg::PublisherDetails_<ContainerAllocator>, typename ContainerAllocator::template rebind<py_trees_ros_interfaces::msg::PublisherDetails_<ContainerAllocator>>::other>;
  _publisher_details_type publisher_details;

  // setters for named parameter idiom
  Type * set__publisher_details(
    const std::vector<py_trees_ros_interfaces::msg::PublisherDetails_<ContainerAllocator>, typename ContainerAllocator::template rebind<py_trees_ros_interfaces::msg::PublisherDetails_<ContainerAllocator>>::other> & _arg)
  {
    this->publisher_details = _arg;
    return this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    py_trees_ros_interfaces::srv::IntrospectPublishers_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const py_trees_ros_interfaces::srv::IntrospectPublishers_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<py_trees_ros_interfaces::srv::IntrospectPublishers_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<py_trees_ros_interfaces::srv::IntrospectPublishers_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      py_trees_ros_interfaces::srv::IntrospectPublishers_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<py_trees_ros_interfaces::srv::IntrospectPublishers_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      py_trees_ros_interfaces::srv::IntrospectPublishers_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<py_trees_ros_interfaces::srv::IntrospectPublishers_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<py_trees_ros_interfaces::srv::IntrospectPublishers_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<py_trees_ros_interfaces::srv::IntrospectPublishers_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED_py_trees_ros_interfaces_srv_IntrospectPublishers_Response
    std::shared_ptr<py_trees_ros_interfaces::srv::IntrospectPublishers_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED_py_trees_ros_interfaces_srv_IntrospectPublishers_Response
    std::shared_ptr<py_trees_ros_interfaces::srv::IntrospectPublishers_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const IntrospectPublishers_Response_ & other) const
  {
    if (this->publisher_details != other.publisher_details) {
      return false;
    }
    return true;
  }
  bool operator!=(const IntrospectPublishers_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct IntrospectPublishers_Response_

// alias to use template instance with default allocator
using IntrospectPublishers_Response =
  py_trees_ros_interfaces::srv::IntrospectPublishers_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace py_trees_ros_interfaces

#endif  // PY_TREES_ROS_INTERFACES__SRV__INTROSPECT_PUBLISHERS__RESPONSE__STRUCT_HPP_
