#ifndef _H_72215FD2DEAF2F96D47FCEFECD52BAA7_MoveBase_Feedback_DCPS_H_
#define _H_72215FD2DEAF2F96D47FCEFECD52BAA7_MoveBase_Feedback_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "MoveBase_Feedback_.h"


namespace py_trees_ros_interfaces
{
    namespace action
    {
        namespace dds_
        {
            class MoveBase_Feedback_TypeSupportInterface;

            typedef MoveBase_Feedback_TypeSupportInterface * MoveBase_Feedback_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < MoveBase_Feedback_TypeSupportInterface> MoveBase_Feedback_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < MoveBase_Feedback_TypeSupportInterface> MoveBase_Feedback_TypeSupportInterface_out;


            class MoveBase_Feedback_DataWriter;

            typedef MoveBase_Feedback_DataWriter * MoveBase_Feedback_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < MoveBase_Feedback_DataWriter> MoveBase_Feedback_DataWriter_var;
            typedef DDS_DCPSInterface_out < MoveBase_Feedback_DataWriter> MoveBase_Feedback_DataWriter_out;


            class MoveBase_Feedback_DataReader;

            typedef MoveBase_Feedback_DataReader * MoveBase_Feedback_DataReader_ptr;
            typedef DDS_DCPSInterface_var < MoveBase_Feedback_DataReader> MoveBase_Feedback_DataReader_var;
            typedef DDS_DCPSInterface_out < MoveBase_Feedback_DataReader> MoveBase_Feedback_DataReader_out;


            class MoveBase_Feedback_DataReaderView;

            typedef MoveBase_Feedback_DataReaderView * MoveBase_Feedback_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < MoveBase_Feedback_DataReaderView> MoveBase_Feedback_DataReaderView_var;
            typedef DDS_DCPSInterface_out < MoveBase_Feedback_DataReaderView> MoveBase_Feedback_DataReaderView_out;

            struct MoveBase_Feedback_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < MoveBase_Feedback_, struct MoveBase_Feedback_Seq_uniq_> MoveBase_Feedback_Seq;
            typedef DDS_DCPSSequence_var < MoveBase_Feedback_Seq> MoveBase_Feedback_Seq_var;
            typedef DDS_DCPSSequence_out < MoveBase_Feedback_Seq> MoveBase_Feedback_Seq_out;

            class  MoveBase_Feedback_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef MoveBase_Feedback_TypeSupportInterface_ptr _ptr_type;
                typedef MoveBase_Feedback_TypeSupportInterface_var _var_type;

                static MoveBase_Feedback_TypeSupportInterface_ptr _duplicate (MoveBase_Feedback_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MoveBase_Feedback_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static MoveBase_Feedback_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MoveBase_Feedback_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                MoveBase_Feedback_TypeSupportInterface_ptr _this () { return this; }


            protected:
                MoveBase_Feedback_TypeSupportInterface () {};
                ~MoveBase_Feedback_TypeSupportInterface () {};
            private:
                MoveBase_Feedback_TypeSupportInterface (const MoveBase_Feedback_TypeSupportInterface &);
                MoveBase_Feedback_TypeSupportInterface & operator = (const MoveBase_Feedback_TypeSupportInterface &);
            };

            class  MoveBase_Feedback_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef MoveBase_Feedback_DataWriter_ptr _ptr_type;
                typedef MoveBase_Feedback_DataWriter_var _var_type;

                static MoveBase_Feedback_DataWriter_ptr _duplicate (MoveBase_Feedback_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MoveBase_Feedback_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static MoveBase_Feedback_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MoveBase_Feedback_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                MoveBase_Feedback_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const MoveBase_Feedback_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const MoveBase_Feedback_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const MoveBase_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const MoveBase_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const MoveBase_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const MoveBase_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const MoveBase_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const MoveBase_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const MoveBase_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const MoveBase_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (MoveBase_Feedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MoveBase_Feedback_& instance_data) = 0;

            protected:
                MoveBase_Feedback_DataWriter () {};
                ~MoveBase_Feedback_DataWriter () {};
            private:
                MoveBase_Feedback_DataWriter (const MoveBase_Feedback_DataWriter &);
                MoveBase_Feedback_DataWriter & operator = (const MoveBase_Feedback_DataWriter &);
            };

            class  MoveBase_Feedback_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef MoveBase_Feedback_DataReader_ptr _ptr_type;
                typedef MoveBase_Feedback_DataReader_var _var_type;

                static MoveBase_Feedback_DataReader_ptr _duplicate (MoveBase_Feedback_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MoveBase_Feedback_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static MoveBase_Feedback_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MoveBase_Feedback_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                MoveBase_Feedback_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (MoveBase_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MoveBase_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MoveBase_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MoveBase_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MoveBase_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MoveBase_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MoveBase_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MoveBase_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MoveBase_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MoveBase_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MoveBase_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MoveBase_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MoveBase_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MoveBase_Feedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MoveBase_Feedback_& instance) = 0;

            protected:
                MoveBase_Feedback_DataReader () {};
                ~MoveBase_Feedback_DataReader () {};
            private:
                MoveBase_Feedback_DataReader (const MoveBase_Feedback_DataReader &);
                MoveBase_Feedback_DataReader & operator = (const MoveBase_Feedback_DataReader &);
            };

            class  MoveBase_Feedback_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef MoveBase_Feedback_DataReaderView_ptr _ptr_type;
                typedef MoveBase_Feedback_DataReaderView_var _var_type;

                static MoveBase_Feedback_DataReaderView_ptr _duplicate (MoveBase_Feedback_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MoveBase_Feedback_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static MoveBase_Feedback_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MoveBase_Feedback_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                MoveBase_Feedback_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (MoveBase_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MoveBase_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MoveBase_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MoveBase_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MoveBase_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MoveBase_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MoveBase_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MoveBase_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MoveBase_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MoveBase_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MoveBase_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MoveBase_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MoveBase_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MoveBase_Feedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MoveBase_Feedback_& instance) = 0;

            protected:
                MoveBase_Feedback_DataReaderView () {};
                ~MoveBase_Feedback_DataReaderView () {};
            private:
                MoveBase_Feedback_DataReaderView (const MoveBase_Feedback_DataReaderView &);
                MoveBase_Feedback_DataReaderView & operator = (const MoveBase_Feedback_DataReaderView &);
            };
        }

    }

}

#endif
