// generated from rosidl_generator_cpp/resource/msg__struct.hpp.em
// generated code does not contain a copyright notice

#ifndef PY_TREES_ROS_INTERFACES__ACTION__DOCK__FEEDBACK__STRUCT_HPP_
#define PY_TREES_ROS_INTERFACES__ACTION__DOCK__FEEDBACK__STRUCT_HPP_

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32) && defined(ERROR)
  #undef ERROR
#endif

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// include message dependencies
#include "unique_identifier_msgs/msg/uuid.hpp"  // action_goal_id

#ifndef _WIN32
# define DEPRECATED_py_trees_ros_interfaces_action_Dock_Feedback __attribute__((deprecated))
#else
# define DEPRECATED_py_trees_ros_interfaces_action_Dock_Feedback __declspec(deprecated)
#endif

namespace py_trees_ros_interfaces
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct Dock_Feedback_
{
  using Type = Dock_Feedback_<ContainerAllocator>;

  explicit Dock_Feedback_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : action_goal_id(_init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->percentage_completed = 0.0f;
    }
  }

  explicit Dock_Feedback_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : action_goal_id(_alloc, _init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->percentage_completed = 0.0f;
    }
  }

  // field types and members
  using _action_goal_id_type =
    unique_identifier_msgs::msg::UUID_<ContainerAllocator>;
  _action_goal_id_type action_goal_id;
  using _percentage_completed_type =
    float;
  _percentage_completed_type percentage_completed;

  // setters for named parameter idiom
  Type * set__action_goal_id(
    const unique_identifier_msgs::msg::UUID_<ContainerAllocator> & _arg)
  {
    this->action_goal_id = _arg;
    return this;
  }
  Type * set__percentage_completed(
    const float & _arg)
  {
    this->percentage_completed = _arg;
    return this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    py_trees_ros_interfaces::action::Dock_Feedback_<ContainerAllocator> *;
  using ConstRawPtr =
    const py_trees_ros_interfaces::action::Dock_Feedback_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<py_trees_ros_interfaces::action::Dock_Feedback_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<py_trees_ros_interfaces::action::Dock_Feedback_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      py_trees_ros_interfaces::action::Dock_Feedback_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<py_trees_ros_interfaces::action::Dock_Feedback_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      py_trees_ros_interfaces::action::Dock_Feedback_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<py_trees_ros_interfaces::action::Dock_Feedback_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<py_trees_ros_interfaces::action::Dock_Feedback_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<py_trees_ros_interfaces::action::Dock_Feedback_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED_py_trees_ros_interfaces_action_Dock_Feedback
    std::shared_ptr<py_trees_ros_interfaces::action::Dock_Feedback_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED_py_trees_ros_interfaces_action_Dock_Feedback
    std::shared_ptr<py_trees_ros_interfaces::action::Dock_Feedback_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Dock_Feedback_ & other) const
  {
    if (this->action_goal_id != other.action_goal_id) {
      return false;
    }
    if (this->percentage_completed != other.percentage_completed) {
      return false;
    }
    return true;
  }
  bool operator!=(const Dock_Feedback_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Dock_Feedback_

// alias to use template instance with default allocator
using Dock_Feedback =
  py_trees_ros_interfaces::action::Dock_Feedback_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace py_trees_ros_interfaces

#endif  // PY_TREES_ROS_INTERFACES__ACTION__DOCK__FEEDBACK__STRUCT_HPP_
