// generated from rosidl_generator_c/resource/msg__struct.h.em
// generated code does not contain a copyright notice

#ifndef PY_TREES_ROS_INTERFACES__MSG__BEHAVIOUR__STRUCT_H_
#define PY_TREES_ROS_INTERFACES__MSG__BEHAVIOUR__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// include message dependencies
// name
// class_name
// message
#include "rosidl_generator_c/string.h"
// own_id
// parent_id
// tip_id
// child_ids
#include "unique_identifier_msgs/msg/uuid__struct.h"

// constants defined in the message
// INVALID
enum
{
  py_trees_ros_interfaces__msg__Behaviour__INVALID = 1u
};
// RUNNING
enum
{
  py_trees_ros_interfaces__msg__Behaviour__RUNNING = 2u
};
// SUCCESS
enum
{
  py_trees_ros_interfaces__msg__Behaviour__SUCCESS = 3u
};
// FAILURE
enum
{
  py_trees_ros_interfaces__msg__Behaviour__FAILURE = 4u
};
// UNKNOWN_TYPE
enum
{
  py_trees_ros_interfaces__msg__Behaviour__UNKNOWN_TYPE = 0u
};
// BEHAVIOUR
enum
{
  py_trees_ros_interfaces__msg__Behaviour__BEHAVIOUR = 1u
};
// SEQUENCE
enum
{
  py_trees_ros_interfaces__msg__Behaviour__SEQUENCE = 2u
};
// SELECTOR
enum
{
  py_trees_ros_interfaces__msg__Behaviour__SELECTOR = 3u
};
// PARALLEL
enum
{
  py_trees_ros_interfaces__msg__Behaviour__PARALLEL = 4u
};
// CHOOSER
enum
{
  py_trees_ros_interfaces__msg__Behaviour__CHOOSER = 5u
};
// DECORATOR
enum
{
  py_trees_ros_interfaces__msg__Behaviour__DECORATOR = 6u
};
// BLACKBOX_LEVEL_DETAIL
enum
{
  py_trees_ros_interfaces__msg__Behaviour__BLACKBOX_LEVEL_DETAIL = 1u
};
// BLACKBOX_LEVEL_COMPONENT
enum
{
  py_trees_ros_interfaces__msg__Behaviour__BLACKBOX_LEVEL_COMPONENT = 2u
};
// BLACKBOX_LEVEL_BIG_PICTURE
enum
{
  py_trees_ros_interfaces__msg__Behaviour__BLACKBOX_LEVEL_BIG_PICTURE = 3u
};
// BLACKBOX_LEVEL_NOT_A_BLACKBOX
enum
{
  py_trees_ros_interfaces__msg__Behaviour__BLACKBOX_LEVEL_NOT_A_BLACKBOX = 4u
};

/// Struct of message py_trees_ros_interfaces/Behaviour
typedef struct py_trees_ros_interfaces__msg__Behaviour
{
  rosidl_generator_c__String name;
  rosidl_generator_c__String class_name;
  unique_identifier_msgs__msg__UUID own_id;
  unique_identifier_msgs__msg__UUID parent_id;
  unique_identifier_msgs__msg__UUID tip_id;
  unique_identifier_msgs__msg__UUID__Sequence child_ids;
  uint8_t type;
  uint8_t blackbox_level;
  uint8_t status;
  rosidl_generator_c__String message;
  bool is_active;
} py_trees_ros_interfaces__msg__Behaviour;

/// Struct for an array of messages
typedef struct py_trees_ros_interfaces__msg__Behaviour__Sequence
{
  py_trees_ros_interfaces__msg__Behaviour * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} py_trees_ros_interfaces__msg__Behaviour__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // PY_TREES_ROS_INTERFACES__MSG__BEHAVIOUR__STRUCT_H_
