#ifndef _H_B0C56DFA3B539EEAA8E60D0ED3A5A14E_BehaviourTree__H_
#define _H_B0C56DFA3B539EEAA8E60D0ED3A5A14E_BehaviourTree__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "py_trees_ros_interfaces/msg/dds_opensplice/Behaviour_.h"
#include "py_trees_ros_interfaces/msg/dds_opensplice/Statistics_.h"


namespace py_trees_ros_interfaces
{
    namespace msg
    {
        namespace dds_
        {
            struct  BehaviourTree_
            {
                struct _behaviours__seq_uniq_{};
                typedef DDS_DCPSUVLSeq< ::py_trees_ros_interfaces::msg::dds_::Behaviour_, struct _behaviours__seq_uniq_ > _behaviours__seq;
                typedef DDS_DCPSSequence_var< _behaviours__seq > _behaviours__seq_var;
                typedef DDS_DCPSSequence_out< _behaviours__seq > _behaviours__seq_out;
                _behaviours__seq behaviours_;
                ::py_trees_ros_interfaces::msg::dds_::Statistics_ statistics_;
            };

            typedef DDS_DCPSStruct_var<BehaviourTree_> BehaviourTree__var;
            typedef DDS_DCPSStruct_out < BehaviourTree_> BehaviourTree__out;

        }

    }

}

#endif /* _H_B0C56DFA3B539EEAA8E60D0ED3A5A14E_BehaviourTree__H_ */
