#ifndef _H_04D74A1865E384ECCF9C8E6CA3761FFB_Behaviour__H_
#define _H_04D74A1865E384ECCF9C8E6CA3761FFB_Behaviour__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "unique_identifier_msgs/msg/dds_opensplice/UUID_.h"


namespace py_trees_ros_interfaces
{
    namespace msg
    {
        namespace dds_
        {
            const ::DDS::Octet Behaviour__INVALID = 1;

            const ::DDS::Octet Behaviour__RUNNING = 2;

            const ::DDS::Octet Behaviour__SUCCESS = 3;

            const ::DDS::Octet Behaviour__FAILURE = 4;

            const ::DDS::Octet Behaviour__UNKNOWN_TYPE = 0;

            const ::DDS::Octet Behaviour__BEHAVIOUR = 1;

            const ::DDS::Octet Behaviour__SEQUENCE = 2;

            const ::DDS::Octet Behaviour__SELECTOR = 3;

            const ::DDS::Octet Behaviour__PARALLEL = 4;

            const ::DDS::Octet Behaviour__CHOOSER = 5;

            const ::DDS::Octet Behaviour__DECORATOR = 6;

            const ::DDS::Octet Behaviour__BLACKBOX_LEVEL_DETAIL = 1;

            const ::DDS::Octet Behaviour__BLACKBOX_LEVEL_COMPONENT = 2;

            const ::DDS::Octet Behaviour__BLACKBOX_LEVEL_BIG_PICTURE = 3;

            const ::DDS::Octet Behaviour__BLACKBOX_LEVEL_NOT_A_BLACKBOX = 4;

            struct  Behaviour_
            {
                struct _child_ids__seq_uniq_{};
                typedef DDS_DCPSUFLSeq< ::unique_identifier_msgs::msg::dds_::UUID_, struct _child_ids__seq_uniq_ > _child_ids__seq;
                typedef DDS_DCPSSequence_var< _child_ids__seq > _child_ids__seq_var;
                typedef DDS_DCPSSequence_out< _child_ids__seq > _child_ids__seq_out;
                ::DDS::String_mgr name_;
                ::DDS::String_mgr class_name_;
                ::unique_identifier_msgs::msg::dds_::UUID_ own_id_;
                ::unique_identifier_msgs::msg::dds_::UUID_ parent_id_;
                ::unique_identifier_msgs::msg::dds_::UUID_ tip_id_;
                _child_ids__seq child_ids_;
                ::DDS::Octet type_;
                ::DDS::Octet blackbox_level_;
                ::DDS::Octet status_;
                ::DDS::String_mgr message_;
                ::DDS::Boolean is_active_;
            };

            typedef DDS_DCPSStruct_var<Behaviour_> Behaviour__var;
            typedef DDS_DCPSStruct_out < Behaviour_> Behaviour__out;

        }

    }

}

#endif /* _H_04D74A1865E384ECCF9C8E6CA3761FFB_Behaviour__H_ */
