#ifndef _H_D1A3A4348F96B7E947EEE9D15A349E04_IntrospectSubscribers_Request_DCPS_H_
#define _H_D1A3A4348F96B7E947EEE9D15A349E04_IntrospectSubscribers_Request_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "IntrospectSubscribers_Request_.h"


namespace py_trees_ros_interfaces
{
    namespace srv
    {
        namespace dds_
        {
            class IntrospectSubscribers_Request_TypeSupportInterface;

            typedef IntrospectSubscribers_Request_TypeSupportInterface * IntrospectSubscribers_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < IntrospectSubscribers_Request_TypeSupportInterface> IntrospectSubscribers_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < IntrospectSubscribers_Request_TypeSupportInterface> IntrospectSubscribers_Request_TypeSupportInterface_out;


            class IntrospectSubscribers_Request_DataWriter;

            typedef IntrospectSubscribers_Request_DataWriter * IntrospectSubscribers_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < IntrospectSubscribers_Request_DataWriter> IntrospectSubscribers_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < IntrospectSubscribers_Request_DataWriter> IntrospectSubscribers_Request_DataWriter_out;


            class IntrospectSubscribers_Request_DataReader;

            typedef IntrospectSubscribers_Request_DataReader * IntrospectSubscribers_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < IntrospectSubscribers_Request_DataReader> IntrospectSubscribers_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < IntrospectSubscribers_Request_DataReader> IntrospectSubscribers_Request_DataReader_out;


            class IntrospectSubscribers_Request_DataReaderView;

            typedef IntrospectSubscribers_Request_DataReaderView * IntrospectSubscribers_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < IntrospectSubscribers_Request_DataReaderView> IntrospectSubscribers_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < IntrospectSubscribers_Request_DataReaderView> IntrospectSubscribers_Request_DataReaderView_out;

            struct IntrospectSubscribers_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < IntrospectSubscribers_Request_, struct IntrospectSubscribers_Request_Seq_uniq_> IntrospectSubscribers_Request_Seq;
            typedef DDS_DCPSSequence_var < IntrospectSubscribers_Request_Seq> IntrospectSubscribers_Request_Seq_var;
            typedef DDS_DCPSSequence_out < IntrospectSubscribers_Request_Seq> IntrospectSubscribers_Request_Seq_out;

            class  IntrospectSubscribers_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef IntrospectSubscribers_Request_TypeSupportInterface_ptr _ptr_type;
                typedef IntrospectSubscribers_Request_TypeSupportInterface_var _var_type;

                static IntrospectSubscribers_Request_TypeSupportInterface_ptr _duplicate (IntrospectSubscribers_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IntrospectSubscribers_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static IntrospectSubscribers_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IntrospectSubscribers_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                IntrospectSubscribers_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                IntrospectSubscribers_Request_TypeSupportInterface () {};
                ~IntrospectSubscribers_Request_TypeSupportInterface () {};
            private:
                IntrospectSubscribers_Request_TypeSupportInterface (const IntrospectSubscribers_Request_TypeSupportInterface &);
                IntrospectSubscribers_Request_TypeSupportInterface & operator = (const IntrospectSubscribers_Request_TypeSupportInterface &);
            };

            class  IntrospectSubscribers_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef IntrospectSubscribers_Request_DataWriter_ptr _ptr_type;
                typedef IntrospectSubscribers_Request_DataWriter_var _var_type;

                static IntrospectSubscribers_Request_DataWriter_ptr _duplicate (IntrospectSubscribers_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IntrospectSubscribers_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static IntrospectSubscribers_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IntrospectSubscribers_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                IntrospectSubscribers_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const IntrospectSubscribers_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const IntrospectSubscribers_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const IntrospectSubscribers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const IntrospectSubscribers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const IntrospectSubscribers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const IntrospectSubscribers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const IntrospectSubscribers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const IntrospectSubscribers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const IntrospectSubscribers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const IntrospectSubscribers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (IntrospectSubscribers_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const IntrospectSubscribers_Request_& instance_data) = 0;

            protected:
                IntrospectSubscribers_Request_DataWriter () {};
                ~IntrospectSubscribers_Request_DataWriter () {};
            private:
                IntrospectSubscribers_Request_DataWriter (const IntrospectSubscribers_Request_DataWriter &);
                IntrospectSubscribers_Request_DataWriter & operator = (const IntrospectSubscribers_Request_DataWriter &);
            };

            class  IntrospectSubscribers_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef IntrospectSubscribers_Request_DataReader_ptr _ptr_type;
                typedef IntrospectSubscribers_Request_DataReader_var _var_type;

                static IntrospectSubscribers_Request_DataReader_ptr _duplicate (IntrospectSubscribers_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IntrospectSubscribers_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static IntrospectSubscribers_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IntrospectSubscribers_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                IntrospectSubscribers_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (IntrospectSubscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (IntrospectSubscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (IntrospectSubscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (IntrospectSubscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (IntrospectSubscribers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (IntrospectSubscribers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (IntrospectSubscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (IntrospectSubscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (IntrospectSubscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (IntrospectSubscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (IntrospectSubscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (IntrospectSubscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (IntrospectSubscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (IntrospectSubscribers_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const IntrospectSubscribers_Request_& instance) = 0;

            protected:
                IntrospectSubscribers_Request_DataReader () {};
                ~IntrospectSubscribers_Request_DataReader () {};
            private:
                IntrospectSubscribers_Request_DataReader (const IntrospectSubscribers_Request_DataReader &);
                IntrospectSubscribers_Request_DataReader & operator = (const IntrospectSubscribers_Request_DataReader &);
            };

            class  IntrospectSubscribers_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef IntrospectSubscribers_Request_DataReaderView_ptr _ptr_type;
                typedef IntrospectSubscribers_Request_DataReaderView_var _var_type;

                static IntrospectSubscribers_Request_DataReaderView_ptr _duplicate (IntrospectSubscribers_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static IntrospectSubscribers_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static IntrospectSubscribers_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static IntrospectSubscribers_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                IntrospectSubscribers_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (IntrospectSubscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (IntrospectSubscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (IntrospectSubscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (IntrospectSubscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (IntrospectSubscribers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (IntrospectSubscribers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (IntrospectSubscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (IntrospectSubscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (IntrospectSubscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (IntrospectSubscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (IntrospectSubscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (IntrospectSubscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (IntrospectSubscribers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (IntrospectSubscribers_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const IntrospectSubscribers_Request_& instance) = 0;

            protected:
                IntrospectSubscribers_Request_DataReaderView () {};
                ~IntrospectSubscribers_Request_DataReaderView () {};
            private:
                IntrospectSubscribers_Request_DataReaderView (const IntrospectSubscribers_Request_DataReaderView &);
                IntrospectSubscribers_Request_DataReaderView & operator = (const IntrospectSubscribers_Request_DataReaderView &);
            };
        }

    }

}

#endif
